#include <stdio.h>
#include <stdlib.h>
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include "SDL.h"
#include "structures.h"
#include "controleur.h"

char* castIntToChar(int n)
{
    switch(n)
    {
        case 0:
            return "0";
            break;
        case 1:
            return "1";
            break;
        case 2:
            return "2";
            break;
        case 3:
            return "3";
            break;
        case 4:
            return "4";
            break;
        case 5:
            return "5";
            break;
        case 6:
            return "6";
            break;
        default:
            return "-1";
            break;
    }
}


char* afficherListe(char** nomsClasses, char** skinsClasses, int nbChoix, TTF_Font* police,SDL_Color couleurTexte)
{
    int i, quitter;
    char* classeChoisie;
    SDL_Surface* fenetre=NULL;
    SDL_Event event;
    SDL_Surface* tabTextes[nbChoix];
    SDL_Surface* tabSkins[nbChoix];
    SDL_Rect positionsTextes[nbChoix];
    SDL_Rect positionsSkins[nbChoix];
    SDL_Color couleurNoire = {0, 0, 0};

    for(i=0;i<nbChoix;i++){
        tabSkins[i]=SDL_LoadBMP(skinsClasses[i]);
        if (!tabSkins[i])
        {
            printf("Unable to load bitmap: %s\n", skinsClasses[i]);
            return 1;
        }
        SDL_SetColorKey(tabSkins[i], SDL_SRCCOLORKEY, SDL_MapRGB(tabSkins[i]->format, 0, 0, 255));
    }

    fenetre = SDL_SetVideoMode(260, nbChoix*tabSkins[0]->h, 32, SDL_HWSURFACE|SDL_DOUBLEBUF|SDL_RESIZABLE);
    SDL_FillRect(fenetre,NULL,SDL_MapRGB(fenetre->format,0,0,0));

    quitter=0;
    while(quitter==0)
    {
        SDL_WaitEvent(&event);
        switch(event.type)
        {
            case SDL_QUIT:
                SDL_FreeSurface(fenetre);
                return "fermer";
                break;
            case SDL_MOUSEBUTTONDOWN:
                for(i=0;i<nbChoix;i++)
                    {
                        if(event.button.y/positionsSkins[0].h==i)
                        {
                            classeChoisie=nomsClasses[i];
                            quitter=1;
                        }
                    }
                break;
            default:
                break;
        }
        for(i=0;i<nbChoix;i++)
        {
            tabTextes[i]=TTF_RenderText_Shaded(police, nomsClasses[i], couleurTexte,couleurNoire);
            positionsSkins[i].y=i*tabSkins[0]->h;
            positionsSkins[i].x=0;
            positionsTextes[i].x=tabSkins[i]->w+4;
            positionsTextes[i].y=positionsSkins[i].y+(tabSkins[i]->h/3);
            SDL_BlitSurface(tabTextes[i],NULL,fenetre,&positionsTextes[i]);
            SDL_BlitSurface(tabSkins[i],NULL,fenetre,&positionsSkins[i]);
        }
        SDL_Flip(fenetre);
    }
    SDL_FreeSurface(fenetre);
    return classeChoisie;
}


int SDL_bis()
{
    int i;
    EtatsJeu etat=SAISIE_JOUEURS;
    SDL_Surface* ecran=NULL;
    SDL_Event event;
    SDL_Surface* logo = NULL;
    SDL_Surface* rectangle = NULL;
    SDL_Surface* texte = NULL;
    SDL_Surface* texte2 = NULL;
    SDL_Surface* texte3 = NULL;
    SDL_Rect pos_logo;
    SDL_Rect pos_texte;
    SDL_Rect pos_texte2;
    SDL_Rect pos_texte3;
    SDL_Rect pos_texte3_bis;
    TTF_Font *police = NULL;
    TTF_Font *petite_police = NULL;

    if ( SDL_Init( SDL_INIT_VIDEO ) < 0 )
    {
        printf( "Unable to init SDL: %s\n", SDL_GetError() );
        return 1;
    }

    if(TTF_Init() == -1)
    {
        fprintf(stderr, "Erreur d'initialisation de TTF_Init : %s\n", TTF_GetError());
        exit(EXIT_FAILURE);
    }

    police=TTF_OpenFont("../resources/fonts/arial.ttf",26);
    SDL_Color couleurNoire = {0, 0, 0};
    SDL_Color couleurBlanche = {255, 255, 255};
    SDL_Color couleurBleue = {10, 30, 80};
    SDL_Color couleurDoree = {190, 190, 120};

    ecran = SDL_SetVideoMode(LARGEUR_CARTE*(LARGEUR_CASE+1), HAUTEUR_CARTE*(HAUTEUR_CASE+2), 32, SDL_HWSURFACE|SDL_DOUBLEBUF);
    if (ecran == NULL) // Si l'ouverture a chou, on le note et on arrte
    {
        fprintf(stderr, "Impossible de charger le mode vido : %s\n", SDL_GetError());
        exit(EXIT_FAILURE);
    }

    SDL_WM_SetCaption("Elder Internal Ignition",NULL);

    texte = TTF_RenderText_Shaded(police, "Entrez le nom du joueur 1", couleurBlanche,couleurNoire);

    SDL_FillRect(ecran,NULL,SDL_MapRGB(ecran->format,0,0,0));

    logo = SDL_LoadBMP("../resources/Skins/logo.bmp");
    if (!logo)
    {
        printf("Unable to load bitmap: %s\n", SDL_GetError());
        return 1;
    }
    pos_logo.x=(ecran->w-logo->w)/2;
    pos_logo.y=0;
    pos_texte.x=(ecran->w-texte->w)/2;
    pos_texte.y=ecran->h-200;
    SDL_BlitSurface(texte,NULL,ecran,&pos_texte);
    SDL_BlitSurface(logo,NULL,ecran,&pos_logo);
    SDL_Flip(ecran);

    char nom_joueur1[TAILLE_NOMS] = "";
    fgets(nom_joueur1, sizeof(nom_joueur1), stdin);
    if(strlen(nom_joueur1)>TAILLE_NOMS-2){
        printf("erreur : nom trop long");
        return -1;
    }
    nom_joueur1[strlen(nom_joueur1)-1]=NULL;

    char nom_joueur2[TAILLE_NOMS] = "";

    texte = TTF_RenderText_Shaded(police, "Entrez le nom du joueur 2", couleurBlanche,couleurNoire);
    SDL_BlitSurface(texte,NULL,ecran,&pos_texte);
    SDL_Flip(ecran);

    fgets(nom_joueur2, sizeof(nom_joueur2), stdin);
    if(strlen(nom_joueur1)>TAILLE_NOMS-2){
        printf("erreur : nom trop long");
        return -1;
    }
    nom_joueur2[strlen(nom_joueur2)-1]=NULL;

    ajouterUnJoueur(nom_joueur1,&etat);
    ajouterUnJoueur(nom_joueur2,&etat);

    police=TTF_OpenFont("../resources/fonts/OLDENGL.ttf",40);
    texte = TTF_RenderText_Shaded(police, "Entrez dans le Royaume !", couleurDoree,couleurBleue);
    pos_texte.x=(ecran->w-texte->w)/2;
    pos_texte.y=ecran->h-200;
    rectangle=SDL_CreateRGBSurface(SDL_HWSURFACE,texte->w,texte->h,NULL,0,0,255,NULL);


    SDL_FillRect(ecran,NULL,SDL_MapRGB(ecran->format,0,0,0));
    SDL_BlitSurface(logo,NULL,ecran,&pos_logo);
    SDL_BlitSurface(texte,NULL,ecran,&pos_texte);
    SDL_BlitSurface(rectangle,NULL,ecran,&pos_texte);
    SDL_Flip(ecran);

    while(etat==LANCEMENT)
    {
        SDL_WaitEvent(&event);
        switch(event.type)
        {
            case SDL_QUIT:
                etat=FERMER;
                break;
            case SDL_MOUSEBUTTONDOWN:
                if (event.button.x<pos_texte.x+texte->w&&event.button.x>pos_texte.x&&event.button.y<pos_texte.y+texte->h&&event.button.y>pos_texte.y)
                    {etat=CONFIGURATION;}
                break;
            default:
                break;
        }
        SDL_BlitSurface(logo,NULL,ecran,&pos_logo);
        SDL_BlitSurface(texte,NULL,ecran,&pos_texte);
        SDL_BlitSurface(rectangle,NULL,ecran,&pos_texte);
        SDL_Flip(ecran);
    }

    SDL_FillRect(ecran,NULL,SDL_MapRGB(ecran->format,0,0,0));
    SDL_Flip(ecran);

    police=TTF_OpenFont("../resources/fonts/OLDENGL.ttf",44);
    petite_police=TTF_OpenFont("../resources/fonts/OLDENGL.ttf",32);

    texte= TTF_RenderText_Shaded(police, nom_joueur1, couleurBlanche,couleurNoire);
    texte2= TTF_RenderText_Shaded(police, nom_joueur2, couleurBlanche, couleurNoire);
    texte3= TTF_RenderText_Shaded(petite_police, "choisissez vos personnages", couleurBlanche, couleurNoire);
    pos_texte.x=ecran->w/4-texte->w/2;
    pos_texte.y=10;
    pos_texte2.x=(3*ecran->w)/4-texte2->w/2;
    pos_texte2.y=10;
    pos_texte3.x=pos_texte.x-(texte3->w-texte->w)/2;
    pos_texte3.y=pos_texte.y+(3*texte3->h)/2;
    pos_texte3_bis.x=pos_texte2.x-(texte3->w-texte2->w)/2;
    pos_texte3_bis.y=pos_texte2.y+(3*texte3->h)/2;

    SDL_BlitSurface(texte,NULL,ecran,&pos_texte);
    SDL_BlitSurface(texte2,NULL,ecran,&pos_texte2);
    SDL_BlitSurface(texte3,NULL,ecran,&pos_texte3);
    SDL_BlitSurface(texte3,NULL,ecran,&pos_texte3_bis);
    SDL_Flip(ecran);

    SDL_Surface textes[6];
    SDL_Rect posTextes[6];
    police=TTF_OpenFont("../resources/fonts/arial.ttf",26);

    char src[50], dest[50];

    for(i=0;i<3;i++)
    {
        strcpy(dest,  "personnage ");
        strcpy(src, castIntToChar(i+1));
        textes[i]= *TTF_RenderText_Shaded(police, strcat(dest, src), couleurBlanche,couleurNoire);
    }

    for(i=3;i<6;i++)
    {
        strcpy(dest,  "personnage ");
        strcpy(src, castIntToChar(i-2));
        textes[i]= *TTF_RenderText_Shaded(police, strcat(dest, src), couleurBlanche,couleurNoire);
    }

    for(i=0;i<3;i++)
    {
        posTextes[i].x=ecran->w/4-textes[i].w/2;
        posTextes[i].y=(i+1)*ecran->h/5;
        SDL_BlitSurface(&textes[i],NULL,ecran,&(posTextes[i]));
    }

    for(i=3;i<6;i++)
    {
        posTextes[i].x=(3*ecran->w)/4-textes[i].w/2;
        posTextes[i].y=posTextes[i-3].y;
        SDL_BlitSurface(&textes[i],NULL,ecran,&posTextes[i]);
    }
    SDL_Flip(ecran);

    char** path_images=obtenirSkinsClasses();
    SDL_Surface* images_classes[nbClasses()];
    SDL_Surface* images_persos[3][2]={{NULL}};
    SDL_Rect positions_images[3][2];
    int numClassePerso[3][2]={{-1,-1},{-1,-1},{-1,-1}};
    int j,p,k;
    j=0;
    p=0;
    char *classeChoisie;
    for(i=0;i<nbClasses();i++)
    {
        images_classes[i]=SDL_LoadBMP(path_images[i]);
        if (!images_classes[i])
        {
            printf("Unable to load bitmap: %s\n", SDL_GetError());
            return 1;
        }
        SDL_SetColorKey(images_classes[i], SDL_SRCCOLORKEY, SDL_MapRGB(images_classes[i]->format, 0, 0, 255));
    }
    int num_classe=-1;
    while(etat==CONFIGURATION)
    {
        SDL_WaitEvent(&event);
        switch(event.type)
        {
            case SDL_QUIT:
                etat=FERMER;
                break;
            case SDL_MOUSEBUTTONDOWN:
                if(event.button.x>posTextes[0].x&&event.button.x<posTextes[0].x+textes[0].w)
                    j=1;
                if(event.button.x>posTextes[3].x&&event.button.x<posTextes[3].x+textes[3].w)
                    j=2;
                for(i=0;i<3;i++){
                    if(event.button.y>posTextes[i].y&&event.button.y<posTextes[i].y+textes[i].h)
                        p=i+1;
                }
                if(j!=0&&p!=0){
                    classeChoisie=afficherListe(obtenirNomsClasses(), obtenirSkinsClasses(), nbClasses(), police, couleurBlanche);
                    if(classeChoisie!="fermer")
                    {
                        numClassePerso[p-1][j-1]=ajouterPersonnage(classeChoisie, p-1, j);
                    }
                    ecran = SDL_SetVideoMode(LARGEUR_CARTE*(LARGEUR_CASE+1), HAUTEUR_CARTE*(HAUTEUR_CASE+2), 32, SDL_HWSURFACE|SDL_DOUBLEBUF);

                }
                break;
            default:
                break;
        }

        for(i=0;i<6;i++){
            SDL_BlitSurface(&textes[i],NULL,ecran,&(posTextes[i]));
        }
        for(i=0;i<3;i++){
            for(k=0;k<2;k++){
                positions_images[i][k].y=posTextes[i].y+textes[i].h;
                positions_images[i][k].x=posTextes[3*k].x+(textes[3*k].w-images_classes[0]->w)/2;
                images_persos[i][k]=images_classes[numClassePerso[i][k]];
                if(numClassePerso[i][k]!=-1)
                {
                    SDL_BlitSurface(images_persos[i][k],NULL,ecran,&positions_images[i][k]);
                }
            }
        }
        SDL_BlitSurface(texte,NULL,ecran,&pos_texte);
        SDL_BlitSurface(texte2,NULL,ecran,&pos_texte2);
        SDL_BlitSurface(texte3,NULL,ecran,&pos_texte3);
        SDL_BlitSurface(texte3,NULL,ecran,&pos_texte3_bis);
        SDL_Flip(ecran);
        p=0;
        j=0;
        num_classe=-1;
    }
    SDL_Quit();
    return 0;
}
